OGRE: Ogre::NULLRenderSystem Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::NULLRenderSystem Class Reference

Implementation of NULL as a rendering system. More...

`#include <OgreNULLRenderSystem.h>`

Inheritance diagram for Ogre::NULLRenderSystem:
[legend]

## Public Member Functions
| NULLRenderSystem ()
virtual | ~NULLRenderSystem (void)
void | _addMetrics (const Metrics &newMetrics)
virtual void | _beginFrame (void)
| Signifies the beginning of a frame, i.e. More...
virtual void | _beginFrameOnce (void)
| Signifies the beginning of the main frame. More...
void | _cleanupDepthBuffers (void)
virtual void | _clearStateAndFlushCommandBuffer (void)
| On D3D11 calls ClearState followed by Flush(). More...
virtual void | _convertOpenVrProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest)
| Converts an OpenVR projection matrix to have the proper depth range and reverse Z settings. More...
virtual void | _convertProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest)
| Converts a uniform projection matrix to suitable for this render system. More...
virtual Window * | _createRenderWindow (const String &name, uint32 width, uint32 height, bool fullScreen, const NameValuePairList *miscParams=0)
| Creates a new rendering window. More...
virtual bool | _createRenderWindows (const RenderWindowDescriptionList &renderWindowDescriptions, WindowList &createdWindows)
| Creates multiple rendering windows. More...
void | _dereferenceSharedDepthBuffer (TextureGpu *depthBuffer)
| Releases the reference count on a shared depth buffer. More...
virtual void | _descriptorSetSamplerCreated (DescriptorSetSampler *newSet)
virtual void | _descriptorSetSamplerDestroyed (DescriptorSetSampler *set)
virtual void | _descriptorSetTexture2Created (DescriptorSetTexture2 *newSet)
virtual void | _descriptorSetTexture2Destroyed (DescriptorSetTexture2 *set)
virtual void | _descriptorSetTextureCreated (DescriptorSetTexture *newSet)
virtual void | _descriptorSetTextureDestroyed (DescriptorSetTexture *set)
virtual void | _descriptorSetUavCreated (DescriptorSetUav *newSet)
virtual void | _descriptorSetUavDestroyed (DescriptorSetUav *set)
virtual void | _dispatch (const HlmsComputePso &pso)
virtual void | _endFrame (void)
| Ends rendering of a frame to the current viewport. More...
virtual void | _endFrameOnce (void)
| Called once per frame, regardless of how many active workspaces there are. More...
virtual void | _executeResourceTransition (ResourceTransition *resTransition)
Viewport & | _getCurrentRenderViewport (void)
virtual const String & | _getDefaultViewportMaterialScheme (void) const
| Returns the default material scheme used by the render system. More...
virtual void | _hlmsBlendblockCreated (HlmsBlendblock *newBlock)
virtual void | _hlmsBlendblockDestroyed (HlmsBlendblock *block)
virtual void | _hlmsComputePipelineStateObjectCreated (HlmsComputePso *newPso)
virtual void | _hlmsComputePipelineStateObjectDestroyed (HlmsComputePso *newPso)
virtual void | _hlmsMacroblockCreated (HlmsMacroblock *newBlock)
virtual void | _hlmsMacroblockDestroyed (HlmsMacroblock *block)
virtual void | _hlmsPipelineStateObjectCreated (HlmsPso *newPso)
virtual void | _hlmsPipelineStateObjectDestroyed (HlmsPso *pso)
virtual void | _hlmsSamplerblockCreated (HlmsSamplerblock *newBlock)
virtual void | _hlmsSamplerblockDestroyed (HlmsSamplerblock *block)
virtual Window * | _initialise (bool autoCreateWindow, const String &windowTitle="OGRE Render Window")
| Start up the renderer using the settings selected (Or the defaults if none have been selected). More...
virtual void | _makeRsProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest, Real nearPlane, Real farPlane, ProjectionType projectionType)
| Takes a regular source projection matrix in range [-1; 1] and converts it to a projection matrix in 'dest' with reverse Z range [1; 0]. More...
virtual RenderSystemContext * | _pauseFrame (void)
| Pause rendering for a frame. More...
virtual void | _render (const CbDrawCallIndexed *cmd)
| Renders the VAO. Assumes _setVertexArrayObject has already been called. More...
virtual void | _render (const CbDrawCallStrip *cmd)
virtual void | _render (const v1::CbDrawCallIndexed *cmd)
| Renders a V1 RenderOperation. Assumes _setRenderOperation has already been called. More...
virtual void | _render (const v1::CbDrawCallStrip *cmd)
virtual void | _render (const v1::RenderOperation &op)
| Render something to the active viewport. More...
virtual void | _renderEmulated (const CbDrawCallIndexed *cmd)
virtual void | _renderEmulated (const CbDrawCallStrip *cmd)
virtual void | _renderEmulatedNoBaseInstance (const CbDrawCallIndexed *cmd)
virtual void | _renderEmulatedNoBaseInstance (const CbDrawCallStrip *cmd)
virtual void | _renderNoBaseInstance (const v1::CbDrawCallIndexed *cmd)
virtual void | _renderNoBaseInstance (const v1::CbDrawCallStrip *cmd)
void | _resetMetrics ()
virtual void | _resourceTransitionCreated (ResourceTransition *resTransition)
virtual void | _resourceTransitionDestroyed (ResourceTransition *resTransition)
virtual void | _resumeFrame (RenderSystemContext *context)
| Resume rendering for a frame. More...
virtual void | _setBindingType (TextureUnitState::BindingType bindigType)
| Set texture unit binding type. More...
virtual void | _setComputePso (const HlmsComputePso *pso)
| Unlike _setPipelineStateObject, the RenderSystem will check if the PSO has changed to avoid redundant state changes (since it's hard to do it at Hlms level) More...
virtual void | _setCurrentDeviceFromTexture (TextureGpu *texture)
| Because Ogre doesn't (yet) have the notion of a 'device' or 'GL context', this function lets Ogre know which device should be used by providing a texture. More...
virtual void | _setGeometryTexture (size_t unit, TextureGpu *tex)
virtual void | _setHlmsSamplerblock (uint8 texUnit, const HlmsSamplerblock *Samplerblock)
| @See HlmsSamplerblock. More...
virtual void | _setIndirectBuffer (IndirectBufferPacked *indirectBuffer)
virtual void | _setPipelineStateObject (const HlmsPso *pso)
| @See HlmsPso More...
virtual void | _setPointParameters (Real size, bool attenuationEnabled, Real constant, Real linear, Real quadratic, Real minSize, Real maxSize)
| Sets the size of points and how they are attenuated with distance. More...
virtual void | _setPointSpritesEnabled (bool enabled)
| Sets whether or not rendering points using OT_POINT_LIST will render point sprites (textured quads) or plain points. More...
virtual void | _setProjectionMatrix (const Matrix4 &m)
| Sets the projection transform matrix. More...
virtual void | _setRenderOperation (const v1::CbRenderOp *cmd)
virtual void | _setSamplers (uint32 slotStart, const DescriptorSetSampler *set)
virtual void | _setSamplersCS (uint32 slotStart, const DescriptorSetSampler *set)
virtual void | _setSurfaceParams (const ColourValue &ambient, const ColourValue &diffuse, const ColourValue &specular, const ColourValue &emissive, Real shininess, TrackVertexColourType tracking=TVC_NONE)
| Sets the surface properties to be used for future rendering. More...
virtual void | _setTessellationDomainTexture (size_t unit, TextureGpu *tex)
virtual void | _setTessellationHullTexture (size_t unit, TextureGpu *tex)
virtual void | _setTexture (size_t unit, TextureGpu *texPtr)
| Sets the texture to bind to a given texture unit. More...
virtual void | _setTextureBlendMode (size_t unit, const LayerBlendModeEx &bm)
| Sets the texture blend modes from a TextureUnitState record. More...
virtual void | _setTextureCoordCalculation (size_t unit, TexCoordCalcMethod m, const Frustum *frustum=0)
| Sets a method for automatically calculating texture coordinates for a stage. More...
virtual void | _setTextureMatrix (size_t unit, const Matrix4 &xform)
| Sets the texture coordinate transformation matrix for a texture unit. More...
virtual void | _setTextureProjectionRelativeTo (bool enabled, const Vector3 &pos)
| Notify the rendersystem that it should adjust texture projection to be relative to a different origin. More...
virtual void | _setTextures (uint32 slotStart, const DescriptorSetTexture *set, uint32 hazardousTexIdx)
virtual void | _setTextures (uint32 slotStart, const DescriptorSetTexture2 *set)
virtual void | _setTexturesCS (uint32 slotStart, const DescriptorSetTexture *set)
virtual void | _setTexturesCS (uint32 slotStart, const DescriptorSetTexture2 *set)
virtual void | _setTextureUnitSettings (size_t texUnit, TextureUnitState &tl)
| Utility function for setting all the properties of a texture unit at once. More...
virtual void | _setUavCS (uint32 slotStart, const DescriptorSetUav *set)
virtual void | _setVertexArrayObject (const VertexArrayObject *vao)
| Part of the low level rendering interface. More...
virtual void | _setVertexTexture (size_t unit, TextureGpu *tex)
| Binds a texture to a vertex, geometry, compute, tessellation hull or tessellation domain sampler. More...
virtual void | _setViewMatrix (const Matrix4 &m)
| Sets the view transform matrix. More...
virtual void | _setWorldMatrices (const Matrix4 *m, unsigned short count)
| Sets multiple world matrices (vertex blending). More...
virtual void | _setWorldMatrix (const Matrix4 &m)
| Sets the world transform matrix. More...
virtual void | _startLegacyV1Rendering (void)
| May override the current VertexArrayObject! More...
void | _update (void)
| Called once per frame, regardless of how many active workspaces there are. More...
virtual void | _useLights (const LightList &lights, unsigned short limit)
| Tells the rendersystem to use the attached set of lights (and no others) up to the number specified (this allows the same list to be used with different count limits) More...
virtual void | addClipPlane (const Plane &p)
| Add a user clipping plane. More...
virtual void | addClipPlane (Real A, Real B, Real C, Real D)
| Add a user clipping plane. More...
virtual void | addListener (Listener *l)
| Adds a listener to the custom events that this render system can raise. More...
virtual bool | areFixedFunctionLightsInViewSpace () const
| Are fixed-function lights provided in view space? Affects optimisation. More...
virtual void | beginGPUSampleProfile (const String &name, uint32 *hashCache)
virtual void | beginProfileEvent (const String &eventName)
| This marks the beginning of an event for GPU profiling. More...
virtual void | beginRenderPassDescriptor (RenderPassDescriptor *desc, TextureGpu *anyTarget, uint8 mipLevel, const Vector4 *viewportSizes, const Vector4 *scissors, uint32 numViewports, bool overlaysEnabled, bool warnIfRtvWasFlushed)
| When the descriptor is set to Load clear, two possible things may happen: More...
virtual void | bindGpuProgramParameters (GpuProgramType gptype, GpuProgramParametersSharedPtr params, uint16 variabilityMask)
| Bind Gpu program parameters. More...
virtual void | bindGpuProgramPassIterationParameters (GpuProgramType gptype)
| Only binds Gpu program parameters used for passes that have more than one iteration rendering. More...
virtual bool | checkExtension (const String &ext) const
| Checks for the presense of an API-specific extension (eg. Vulkan, GL) More...
virtual void | clearFrameBuffer (RenderPassDescriptor *renderPassDesc, TextureGpu *anyTarget, uint8 mipLevel)
| Immediately clears the whole frame buffer on the selected RenderPassDescriptor. More...
virtual void | convertColourValue (const ColourValue &colour, uint32 *pDest)
| Generates a packed data version of the passed in ColourValue suitable for use as with this RenderSystem. More...
virtual HardwareOcclusionQuery * | createHardwareOcclusionQuery (void)
| Create an object for performing hardware occlusion queries. More...
virtual RenderPassDescriptor * | createRenderPassDescriptor (void)
virtual RenderSystemCapabilities * | createRenderSystemCapabilities (void) const
| Query the real capabilities of the GPU and driver in the RenderSystem. More...
virtual void | deinitGPUProfiling (void)
virtual void | destroyHardwareOcclusionQuery (HardwareOcclusionQuery *hq)
| Destroy a hardware occlusion query object. More...
void | destroyRenderPassDescriptor (RenderPassDescriptor *renderPassDesc)
virtual void | destroyRenderWindow (Window *window)
| Destroys a render window. More...
virtual void | endGPUSampleProfile (const String &name)
virtual void | endProfileEvent (void)
| Ends the currently active GPU profiling event. More...
virtual void | endRenderPassDescriptor (void)
virtual void | executeRenderPassDescriptorDelayedActions (void)
| Metal needs to delay RenderCommand creation to the last minute, because we can't issue blit operations (e.g. More...
virtual void | flushCommands (void)
virtual void | flushUAVs (void)
| Forces to take effect all the queued UAV binding requests. More...
const RenderSystemCapabilities * | getCapabilities (void) const
| Gets the capabilities of the render system. More...
virtual VertexElementType | getColourVertexElementType (void) const
| Get the native VertexElementType for a compact 32-bit colour value for this rendersystem. More...
virtual ConfigOptionMap & | getConfigOptions (void)
| Returns the details of this API's configuration options. More...
RenderPassDescriptor * | getCurrentPassDescriptor (void)
Viewport * | getCurrentRenderViewports (void)
virtual void | getCustomAttribute (const String &name, void *pData)
| Gets a custom (maybe platform-specific) attribute. More...
bool | getDebugShaders (void) const
virtual TextureGpu * | getDepthBufferFor (TextureGpu *colourTexture, uint16 poolId, bool preferDepthTexture, PixelFormatGpu depthBufferFormat)
virtual unsigned int | getDisplayMonitorCount () const
| Gets the number of display monitors. More...
virtual const DriverVersion & | getDriverVersion (void) const
| Returns the driver version. More...
virtual String | getErrorDescription (long errorNumber) const
| Returns a description of an error code. More...
virtual const String & | getFriendlyName (void) const
| Returns the friendly name of the render system. More...
v1::HardwareVertexBufferSharedPtr | getGlobalInstanceVertexBuffer () const
| Returns the global instance vertex buffer. More...
v1::VertexDeclaration * | getGlobalInstanceVertexBufferVertexDeclaration () const
| Gets vertex declaration for the global vertex buffer for the global instancing. More...
size_t | getGlobalNumberOfInstances () const
| Gets the global number of instances. More...
virtual Real | getHorizontalTexelOffset (void)
| Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem. More...
virtual bool | getInvertVertexWinding (void) const
| Indicates whether or not the vertex windings set will be inverted for the current render (e.g. More...
uint32 | getMaxBoundViewports (void)
virtual Real | getMaximumDepthInputValue (void)
| Gets the maximum (farthest) depth value to be used when rendering using identity transforms. More...
const Metrics & | getMetrics () const
virtual Real | getMinimumDepthInputValue (void)
| Gets the minimum (closest) depth value to be used when rendering using identity transforms. More...
RenderSystemCapabilities * | getMutableCapabilities ()
| Get a pointer to the current capabilities being used by the RenderSystem. More...
virtual const String & | getName (void) const
| Returns the name of the rendering system. More...
uint16 | getNativeShadingLanguageVersion () const
| Gets the native shading language version for this render system. More...
virtual const PixelFormatToShaderType * | getPixelFormatToShaderType (void) const
virtual const StringVector & | getRenderSystemEvents (void) const
| Gets a list of the rendersystem specific events that this rendersystem can raise. More...
virtual Real | getRSDepthRange (void) const
| OpenGL depth is in range [-1;1] so it returns 2.0f; D3D11 & Metal are in range [0;1] so it returns 1.0f;. More...
const StencilParams & | getStencilBufferParams (void) const
TextureGpuManager * | getTextureGpuManager (void) const
VaoManager * | getVaoManager (void) const
virtual Real | getVerticalTexelOffset (void)
| Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem. More...
bool | getWBufferEnabled (void) const
| Returns true if the renderer will try to use W-buffers when available. More...
virtual bool | hasAnisotropicMipMapFilter () const
| Determines if the system has anisotropic mip map filter support. More...
virtual void | initGPUProfiling (void)
virtual void | initialiseFromRenderSystemCapabilities (RenderSystemCapabilities *caps, Window *primary)
| Initialize the render system from the capabilities. More...
virtual bool | isGpuProgramBound (GpuProgramType gptype)
| Returns whether or not a Gpu program of the given type is currently bound. More...
bool | isReverseDepth (void) const
virtual bool | isStaticBufferLockable () const
virtual void | markProfileEvent (const String &event)
| Marks an instantaneous event for graphics profilers. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | postExtraThreadsStarted ()
virtual void | preExtraThreadsStarted ()
| Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might access the rendering API are registered. More...
void | queueBindUAVs (const DescriptorSetUav *descSetUav)
| Queues the binding of an UAV to the binding point/slot. More...
virtual void | registerThread ()
| Register the an additional thread which may make calls to rendersystem-related objects. More...
virtual void | reinitialise (void)
| Restart the renderer (normally following a change in settings). More...
virtual void | removeListener (Listener *l)
| Remove a listener to the custom events that this render system can raise. More...
virtual void | resetClipPlanes ()
| Clears the user clipping region. More...
virtual void | setClipPlanes (const PlaneList &clipPlanes)
| Sets the user clipping region. More...
virtual void | setClipPlanesImpl (const PlaneList &clipPlanes)
| Internal method used to set the underlying clip planes when needed. More...
virtual void | setConfigOption (const String &name, const String &value)
| Sets an option for this API. More...
virtual void | setCurrentPassIterationCount (const size_t count)
| set the current multi pass count value. More...
void | setDebugShaders (bool bDebugShaders)
| Instructs the RenderSystem to compile shaders without optimizations and with debug information, for easier debugging on APIs that support it. More...
virtual void | setDeriveDepthBias (bool derive, float baseValue=0.0f, float multiplier=0.0f, float slopeScale=0.0f)
| Tell the render system whether to derive a depth bias on its own based on the values passed to it in setCurrentPassIterationCount. More...
virtual bool | setDrawBuffer (ColourBufferType colourBuffer)
| Sets the colour buffer that the render system will to draw. More...
void | setGlobalInstanceVertexBuffer (const v1::HardwareVertexBufferSharedPtr &val)
| Sets the global instance vertex buffer. More...
void | setGlobalInstanceVertexBufferVertexDeclaration (v1::VertexDeclaration *val)
| Sets vertex declaration for the global vertex buffer for the global instancing. More...
void | setGlobalNumberOfInstances (const size_t val)
| Sets the global number of instances. More...
void | setInvertVertexWinding (bool invert)
| Sets whether or not vertex windings set should be inverted; this can be important for rendering reflections. More...
void | setMetricsRecordingEnabled (bool bEnable)
virtual void | setStencilBufferParams (uint32 refValue, const StencilParams &stencilParams)
| This method allows you to set all the stencil buffer parameters in one call. More...
void | setUavStartingSlot (uint32 startingSlot)
| In Direct3D11, UAV & RenderTargets share the same slots. More...
void | setWBufferEnabled (bool enabled)
| Sets whether or not W-buffers are enabled if they are available for this renderer. More...
virtual void | shutdown (void)
| Shutdown the renderer and cleanup resources. More...
virtual void | unregisterThread ()
| Unregister an additional thread which may make calls to rendersystem-related objects. More...
virtual void | updateCompositorManager (CompositorManager2 *compositorManager)
| This gives the renderer a chance to perform the compositor update in a special way. More...
virtual void | useCustomRenderSystemCapabilities (RenderSystemCapabilities *capabilities)
| Force the render system to use the special capabilities. More...
virtual String | validateConfigOptions (void)
| Validates the options set for the rendering system, returning a message if there are problems. More...
virtual bool | validateDevice (bool forceDeviceElection=false)
| Some render systems have moments when GPU device is temporarily unavailable, for example when D3D11 device is lost, or when iOS app is in background, etc. More...
virtual SampleDescription | validateSampleDescription (const SampleDescription &sampleDesc, PixelFormatGpu format)
| Returns supported sample description for requested FSAA mode, with graceful downgrading. More...

## Static Public Member Functions
static Listener * | getSharedListener (void)
| Retrieve a pointer to the current shared render system listener. More...
static CompareFunction | reverseCompareFunction (CompareFunction depthFunc)
| Reverts the compare order e.g. More...
static void | setSharedListener (Listener *listener)
| Sets shared listener. More...

## Detailed Description

Implementation of NULL as a rendering system.

## Constructor & Destructor Documentation

## ◆ NULLRenderSystem()

Ogre::NULLRenderSystem::NULLRenderSystem | ( |  | ) |

## ◆ ~NULLRenderSystem()

virtual Ogre::NULLRenderSystem::~NULLRenderSystem | ( | void |  | ) |
| virtual

## Member Function Documentation

## ◆ _addMetrics()

void Ogre::RenderSystem::_addMetrics | ( | const Metrics & | newMetrics | ) |
| inherited

## ◆ _beginFrame()

virtual void Ogre::NULLRenderSystem::_beginFrame | ( | void |  | ) |
| virtual

Signifies the beginning of a frame, i.e.

the start of rendering on a single viewport. Will occur several times per complete frame if multiple viewports exist.

Implements Ogre::RenderSystem.

## ◆ _beginFrameOnce()

virtual void Ogre::RenderSystem::_beginFrameOnce | ( | void |  | ) |
| virtualinherited

Signifies the beginning of the main frame.

i.e. will only be called once per frame, not per viewport

Reimplemented in Ogre::MetalRenderSystem.

## ◆ _cleanupDepthBuffers()

void Ogre::RenderSystem::_cleanupDepthBuffers | ( | void |  | ) |
| inherited

## ◆ _clearStateAndFlushCommandBuffer()

virtual void Ogre::RenderSystem::_clearStateAndFlushCommandBuffer | ( | void |  | ) |
| virtualinherited

On D3D11 calls ClearState followed by Flush().

On GL3+ it calls glFlush

Do not call this function while inside rendering internals, as it will clear the device state, thus leaving it inconsistent with what we think it is set to.

Reimplemented in Ogre::D3D11RenderSystem.

## ◆ _convertOpenVrProjectionMatrix()

virtual void Ogre::RenderSystem::_convertOpenVrProjectionMatrix | ( | const Matrix4 & | matrix,
|  | Matrix4 & | dest
| ) |  |
| virtualinherited

Converts an OpenVR projection matrix to have the proper depth range and reverse Z settings.

Parameters

  matrix |
  dest |

Reimplemented in Ogre::GL3PlusRenderSystem.

## ◆ _convertProjectionMatrix()

virtual void Ogre::NULLRenderSystem::_convertProjectionMatrix | ( | const Matrix4 & | matrix,
|  | Matrix4 & | dest
| ) |  |
| inlinevirtual

Converts a uniform projection matrix to suitable for this render system.

Remarks
  Because different APIs have different requirements (some incompatible) for the projection matrix, this method allows each to implement their own correctly and pass back a generic OGRE matrix for storage in the engine.

Reimplemented from Ogre::RenderSystem.

## ◆ _createRenderWindow()

virtual Window* Ogre::NULLRenderSystem::_createRenderWindow | ( | const String & | name,
|  | uint32 | width,
|  | uint32 | height,
|  | bool | fullScreen,
|  | const NameValuePairList * | miscParams = `0`
| ) |  |
| virtual

Creates a new rendering window.

Remarks
  This method creates a new rendering window as specified by the paramteters. The rendering system could be responible for only a single window (e.g. in the case of a game), or could be in charge of multiple ones (in the case of a level editor). The option to create the window as a child of another is therefore given. This method will create an appropriate subclass of RenderWindow depending on the API and platform implementation.

  After creation, this window can be retrieved using getRenderTarget().

Parameters

  name | The name of the window. Used in other methods later like setRenderTarget and getRenderTarget.
  width | The width of the new window.
  height | The height of the new window.
  fullScreen | Specify true to make the window full screen without borders, title bar or menu bar.
  miscParams | A NameValuePairList describing the other parameters for the new rendering window. Options are case sensitive. Unrecognised parameters will be ignored silently. These values might be platform dependent, but these are present for all platforms unless indicated otherwise:
  Key | Type/Values | Default | Description | Notes
  title | Any string | RenderTarget name | The title of the window that will appear in the title bar |
  colourDepth | 16, 32 | Desktop depth | Colour depth of the resulting rendering window; only applies if fullScreen | Win32 Specific
  left | Positive integers | Centred | Screen x coordinate from left |
  top | Positive integers | Centred | Screen y coordinate from left |
  depthBuffer | true, false | true | Use depth buffer | DirectX9 specific
  externalWindowHandle | Win32: HWND as integer GLX: poslong:posint:poslong (display*:screen:windowHandle) or poslong:posint:poslong:poslong (display*:screen:windowHandle:XVisualInfo*) OS X Cocoa: OgreGLView address as an integer. You can pass NSView or NSWindow too, but should perform OgreGLView callbacks into the Ogre manually. iOS: UIWindow address as an integer | 0 (none) | External window handle, for embedding the OGRE render in an existing window |
  externalGLControl | true, false | false | Let the external window control OpenGL i.e. don't select a pixel format for the window, do not change v-sync and do not swap buffer. When set to true, the calling application is responsible of OpenGL initialization and buffer swapping. It should also create an OpenGL context for its own rendering, Ogre will create one for its use. Then the calling application must also enable Ogre OpenGL context before calling any Ogre function and restore its OpenGL context after these calls. | OpenGL specific
  externalGLContext | Context as Unsigned Long | 0 (create own context) | Use an externally created GL context | OpenGL Specific
  parentWindowHandle | Win32: HWND as integer GLX: poslong:posint:poslong (display*:screen:windowHandle) or poslong:posint:poslong:poslong (display*:screen:windowHandle:XVisualInfo*) | 0 (none) | Parent window handle, for embedding the OGRE in a child of an external window |
  contentScalingFactor | Positive Float greater than 1.0 | The default content scaling factor of the screen | Specifies the CAEAGLLayer content scaling factor. Only supported on iOS 4 or greater. This can be useful to limit the resolution of the OpenGL ES backing store. For example, the iPhone 4's native resolution is 960 x 640. Windows are always 320 x 480, if you would like to limit the display to 720 x 480, specify 1.5 as the scaling factor. | iOS Specific |
  externalViewHandle | UIView pointer as an integer | 0 | External view handle, for rendering OGRE render in an existing view | iOS Specific |
  externalViewControllerHandle | UIViewController pointer as an integer | 0 | External view controller handle, for embedding OGRE in an existing view controller | iOS Specific |
  externalSharegroup | EAGLSharegroup pointer as an integer | 0 | External sharegroup, used to shared GL resources between contexts | iOS Specific |
  Full Screen | true, false | false | Specify whether to create the window in full screen mode | OS X Specific |
  MSAA | Positive integer (usually 1, 2, 4, 8, 16) | 1 | Multisample antialiasing factor |
  MSAA_Quality | Depends on RenderSystem and hardware. Currently supports: 0 ... infinite number (depends on HW) | Blank | Full screen antialiasing hint |
  displayFrequency | Refresh rate in Hertz (e.g. 60, 75, 100) | Desktop vsync rate | Display frequency rate, for fullscreen mode |
  vsync | true, false | false | Synchronize buffer swaps to monitor vsync, eliminating tearing at the expense of a fixed frame rate |
  vsyncInterval | 1, 2, 3, 4 | 1 | If vsync is enabled, the minimum number of vertical blanks that should occur between renders. For example if vsync is enabled, the refresh rate is 60 and this is set to 2, then the frame rate will be locked at 30. |
  border | none, fixed, resize | resize | The type of window border (in windowed mode) |
  outerDimensions | true, false | false | Whether the width/height is expressed as the size of the outer window, rather than the content area |
  useNVPerfHUD | true, false | false | Enable the use of nVidia NVPerfHUD |
  gamma | true, false | false | Enable hardware conversion from linear colour space to gamma colour space on rendering to the window. |
  enableDoubleClick | true, false | false | Enable the window to keep track and transmit double click messages. | Win32 Specific
  MSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Full screen antialiasing factor | Android Specific
  CSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Coverage sampling factor (https://www.khronos.org/registry/egl/extensions/NV/EGL_NV_coverage_sample.txt) | Android Specific
  maxColourBufferSize | Positive integer (usually 16, 32) | 32 | Max EGL_BUFFER_SIZE | Android Specific
  minColourBufferSize | Positive integer (usually 16, 32) | 16 | Min EGL_BUFFER_SIZE | Android Specific
  maxStencilBufferSize | Positive integer (usually 0, 8) | 0 | EGL_STENCIL_SIZE | Android Specific
  maxDepthBufferSize | Positive integer (usually 0, 16, 24) | 16 | EGL_DEPTH_SIZE | Android Specific

Implements Ogre::RenderSystem.

## ◆ _createRenderWindows()

virtual bool Ogre::RenderSystem::_createRenderWindows | ( | const RenderWindowDescriptionList & | renderWindowDescriptions,
|  | WindowList & | createdWindows
| ) |  |
| virtualinherited

Creates multiple rendering windows.

Parameters

  renderWindowDescriptions | Array of structures containing the descriptions of each render window. The structure's members are the same as the parameters of _createRenderWindow: name width height fullScreen miscParams See _createRenderWindow for details about each member.
  createdWindows | This array will hold the created render windows.

Returns
  true on success.

Reimplemented in Ogre::GL3PlusRenderSystem.

## ◆ _dereferenceSharedDepthBuffer()

void Ogre::RenderSystem::_dereferenceSharedDepthBuffer | ( | TextureGpu * | depthBuffer | ) |
| inherited

Releases the reference count on a shared depth buffer.

Does nothing if input is not a shared depth buffer.

## ◆ _descriptorSetSamplerCreated()

virtual void Ogre::RenderSystem::_descriptorSetSamplerCreated | ( | DescriptorSetSampler * | newSet | ) |
| inlinevirtualinherited

## ◆ _descriptorSetSamplerDestroyed()

virtual void Ogre::RenderSystem::_descriptorSetSamplerDestroyed | ( | DescriptorSetSampler * | set | ) |
| inlinevirtualinherited

## ◆ _descriptorSetTexture2Created()

virtual void Ogre::RenderSystem::_descriptorSetTexture2Created | ( | DescriptorSetTexture2 * | newSet | ) |
| inlinevirtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _descriptorSetTexture2Destroyed()

virtual void Ogre::RenderSystem::_descriptorSetTexture2Destroyed | ( | DescriptorSetTexture2 * | set | ) |
| inlinevirtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _descriptorSetTextureCreated()

virtual void Ogre::RenderSystem::_descriptorSetTextureCreated | ( | DescriptorSetTexture * | newSet | ) |
| inlinevirtualinherited

Reimplemented in Ogre::D3D11RenderSystem.

## ◆ _descriptorSetTextureDestroyed()

virtual void Ogre::RenderSystem::_descriptorSetTextureDestroyed | ( | DescriptorSetTexture * | set | ) |
| inlinevirtualinherited

Reimplemented in Ogre::D3D11RenderSystem.

## ◆ _descriptorSetUavCreated()

virtual void Ogre::RenderSystem::_descriptorSetUavCreated | ( | DescriptorSetUav * | newSet | ) |
| inlinevirtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _descriptorSetUavDestroyed()

virtual void Ogre::RenderSystem::_descriptorSetUavDestroyed | ( | DescriptorSetUav * | set | ) |
| inlinevirtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _dispatch()

virtual void Ogre::NULLRenderSystem::_dispatch | ( | const HlmsComputePso & | pso | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ _endFrame()

virtual void Ogre::NULLRenderSystem::_endFrame | ( | void |  | ) |
| virtual

Ends rendering of a frame to the current viewport.

Implements Ogre::RenderSystem.

## ◆ _endFrameOnce()

virtual void Ogre::RenderSystem::_endFrameOnce | ( | void |  | ) |
| virtualinherited

Called once per frame, regardless of how many active workspaces there are.

Gets called AFTER all RenderWindows have been swapped.

Reimplemented in Ogre::MetalRenderSystem.

## ◆ _executeResourceTransition()

virtual void Ogre::RenderSystem::_executeResourceTransition | ( | ResourceTransition * | resTransition | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GL3PlusRenderSystem.

## ◆ _getCurrentRenderViewport()

Viewport& Ogre::RenderSystem::_getCurrentRenderViewport | ( | void |  | ) |
| inlineinherited

## ◆ _getDefaultViewportMaterialScheme()

virtual const String& Ogre::RenderSystem::_getDefaultViewportMaterialScheme | ( | void |  | ) | const
| virtualinherited

Returns the default material scheme used by the render system.

Systems that use the RTSS to emulate a fixed function pipeline (e.g. OpenGL ES 2, GL3+, DX11) need to override this function to return the default material scheme of the RTSS ShaderGenerator.

This is currently only used to set the default material scheme for viewports. It is a necessary step on these render systems for render textures to be rendered into properly.

Referenced by Ogre::CompositorPassSceneDef::CompositorPassSceneDef().

## ◆ _hlmsBlendblockCreated()

virtual void Ogre::RenderSystem::_hlmsBlendblockCreated | ( | HlmsBlendblock * | newBlock | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GLES2RenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _hlmsBlendblockDestroyed()

virtual void Ogre::RenderSystem::_hlmsBlendblockDestroyed | ( | HlmsBlendblock * | block | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GLES2RenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _hlmsComputePipelineStateObjectCreated()

virtual void Ogre::RenderSystem::_hlmsComputePipelineStateObjectCreated | ( | HlmsComputePso * | newPso | ) |
| inlinevirtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _hlmsComputePipelineStateObjectDestroyed()

virtual void Ogre::RenderSystem::_hlmsComputePipelineStateObjectDestroyed | ( | HlmsComputePso * | newPso | ) |
| inlinevirtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _hlmsMacroblockCreated()

virtual void Ogre::RenderSystem::_hlmsMacroblockCreated | ( | HlmsMacroblock * | newBlock | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GLES2RenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _hlmsMacroblockDestroyed()

virtual void Ogre::RenderSystem::_hlmsMacroblockDestroyed | ( | HlmsMacroblock * | block | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GLES2RenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _hlmsPipelineStateObjectCreated()

virtual void Ogre::RenderSystem::_hlmsPipelineStateObjectCreated | ( | HlmsPso * | newPso | ) |
| inlinevirtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GLES2RenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _hlmsPipelineStateObjectDestroyed()

virtual void Ogre::RenderSystem::_hlmsPipelineStateObjectDestroyed | ( | HlmsPso * | pso | ) |
| inlinevirtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GLES2RenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _hlmsSamplerblockCreated()

virtual void Ogre::RenderSystem::_hlmsSamplerblockCreated | ( | HlmsSamplerblock * | newBlock | ) |
| inlinevirtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GLES2RenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _hlmsSamplerblockDestroyed()

virtual void Ogre::RenderSystem::_hlmsSamplerblockDestroyed | ( | HlmsSamplerblock * | block | ) |
| inlinevirtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GLES2RenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _initialise()

virtual Window* Ogre::NULLRenderSystem::_initialise | ( | bool | autoCreateWindow,
|  | const String & | windowTitle = `"OGRE Render Window"`
| ) |  |
| virtual

Start up the renderer using the settings selected (Or the defaults if none have been selected).

Remarks
  Called by Root::setRenderSystem. Shouldn't really be called directly, although this can be done if the app wants to.

Parameters

  autoCreateWindow | If true, creates a render window automatically, based on settings chosen so far. This saves an extra call to _createRenderWindow for the main render window.
  windowTitle | Sets the app window title

Returns
  A pointer to the automatically created window, if requested, otherwise null.

Reimplemented from Ogre::RenderSystem.

## ◆ _makeRsProjectionMatrix()

virtual void Ogre::RenderSystem::_makeRsProjectionMatrix | ( | const Matrix4 & | matrix,
|  | Matrix4 & | dest,
|  | Real | nearPlane,
|  | Real | farPlane,
|  | ProjectionType | projectionType
| ) |  |
| virtualinherited

Takes a regular source projection matrix in range [-1; 1] and converts it to a projection matrix in 'dest' with reverse Z range [1; 0].

_convertProjectionMatrix does the same thing but is more generic. This version assumes a standard projection matrix (i.e. not oblique) to maximize precision

Parameters

  matrix |
  dest |
  nearPlane |
  farPlane |
  projectionType |

Reimplemented in Ogre::GL3PlusRenderSystem.

## ◆ _pauseFrame()

virtual RenderSystemContext* Ogre::RenderSystem::_pauseFrame | ( | void |  | ) |
| virtualinherited

Pause rendering for a frame.

This has to be called after _beginFrame and before _endFrame. Will usually be called by the SceneManager, don't use this manually unless you know what you are doing.

Reimplemented in Ogre::D3D9RenderSystem.

## ◆ _render() [1/5]

virtual void Ogre::NULLRenderSystem::_render | ( | const CbDrawCallIndexed * | cmd | ) |
| virtual

Renders the VAO. Assumes _setVertexArrayObject has already been called.

Implements Ogre::RenderSystem.

## ◆ _render() [2/5]

virtual void Ogre::NULLRenderSystem::_render | ( | const CbDrawCallStrip * | cmd | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ _render() [3/5]

virtual void Ogre::NULLRenderSystem::_render | ( | const v1::CbDrawCallIndexed * | cmd | ) |
| virtual

Renders a V1 RenderOperation. Assumes _setRenderOperation has already been called.

Implements Ogre::RenderSystem.

## ◆ _render() [4/5]

virtual void Ogre::NULLRenderSystem::_render | ( | const v1::CbDrawCallStrip * | cmd | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ _render() [5/5]

virtual void Ogre::RenderSystem::_render | ( | const v1::RenderOperation & | op | ) |
| virtualinherited

Render something to the active viewport.

Low-level rendering interface to perform rendering operations. Unlikely to be used directly by client applications, since the SceneManager and various support classes will be responsible for calling this method. Can only be called between _beginScene and _endScene

Parameters

  op | A rendering operation instance, which contains details of the operation to be performed.

Reimplemented in Ogre::MetalRenderSystem, Ogre::GLES2RenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _renderEmulated() [1/2]

virtual void Ogre::NULLRenderSystem::_renderEmulated | ( | const CbDrawCallIndexed * | cmd | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ _renderEmulated() [2/2]

virtual void Ogre::NULLRenderSystem::_renderEmulated | ( | const CbDrawCallStrip * | cmd | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ _renderEmulatedNoBaseInstance() [1/2]

virtual void Ogre::RenderSystem::_renderEmulatedNoBaseInstance | ( | const CbDrawCallIndexed * | cmd | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GLES2RenderSystem, and Ogre::GL3PlusRenderSystem.

## ◆ _renderEmulatedNoBaseInstance() [2/2]

virtual void Ogre::RenderSystem::_renderEmulatedNoBaseInstance | ( | const CbDrawCallStrip * | cmd | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GLES2RenderSystem, and Ogre::GL3PlusRenderSystem.

## ◆ _renderNoBaseInstance() [1/2]

virtual void Ogre::RenderSystem::_renderNoBaseInstance | ( | const v1::CbDrawCallIndexed * | cmd | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GLES2RenderSystem, and Ogre::GL3PlusRenderSystem.

## ◆ _renderNoBaseInstance() [2/2]

virtual void Ogre::RenderSystem::_renderNoBaseInstance | ( | const v1::CbDrawCallStrip * | cmd | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GLES2RenderSystem, and Ogre::GL3PlusRenderSystem.

## ◆ _resetMetrics()

void Ogre::RenderSystem::_resetMetrics | ( |  | ) |
| inherited

## ◆ _resourceTransitionCreated()

virtual void Ogre::RenderSystem::_resourceTransitionCreated | ( | ResourceTransition * | resTransition | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GL3PlusRenderSystem.

## ◆ _resourceTransitionDestroyed()

virtual void Ogre::RenderSystem::_resourceTransitionDestroyed | ( | ResourceTransition * | resTransition | ) |
| inlinevirtualinherited

Reimplemented in Ogre::GL3PlusRenderSystem.

## ◆ _resumeFrame()

virtual void Ogre::RenderSystem::_resumeFrame | ( | RenderSystemContext * | context | ) |
| virtualinherited

Resume rendering for a frame.

This has to be called after a _pauseFrame call Will usually be called by the SceneManager, don't use this manually unless you know what you are doing.

Parameters

  context | the render system context, as returned by _pauseFrame

Reimplemented in Ogre::D3D9RenderSystem.

## ◆ _setBindingType()

virtual void Ogre::RenderSystem::_setBindingType | ( | TextureUnitState::BindingType | bindigType | ) |
| virtualinherited

Set texture unit binding type.

Reimplemented in Ogre::D3D11RenderSystem.

## ◆ _setComputePso()

virtual void Ogre::NULLRenderSystem::_setComputePso | ( | const HlmsComputePso * | pso | ) |
| virtual

Unlike _setPipelineStateObject, the RenderSystem will check if the PSO has changed to avoid redundant state changes (since it's hard to do it at Hlms level)

Implements Ogre::RenderSystem.

## ◆ _setCurrentDeviceFromTexture()

virtual void Ogre::NULLRenderSystem::_setCurrentDeviceFromTexture | ( | TextureGpu * | texture | ) |
| virtual

Because Ogre doesn't (yet) have the notion of a 'device' or 'GL context', this function lets Ogre know which device should be used by providing a texture.

Parameters

  texture | Cannot be null.

Implements Ogre::RenderSystem.

## ◆ _setGeometryTexture()

virtual void Ogre::RenderSystem::_setGeometryTexture | ( | size_t | unit,
|  | TextureGpu * | tex
| ) |  |
| virtualinherited

Reimplemented in Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _setHlmsSamplerblock()

virtual void Ogre::NULLRenderSystem::_setHlmsSamplerblock | ( | uint8 | texUnit,
|  | const HlmsSamplerblock * | Samplerblock
| ) |  |
| virtual

@See HlmsSamplerblock.

This function MUST be called after _setTexture, not before. Otherwise not all APIs may see the change.

Implements Ogre::RenderSystem.

## ◆ _setIndirectBuffer()

virtual void Ogre::NULLRenderSystem::_setIndirectBuffer | ( | IndirectBufferPacked * | indirectBuffer | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ _setPipelineStateObject()

virtual void Ogre::NULLRenderSystem::_setPipelineStateObject | ( | const HlmsPso * | pso | ) |
| virtual

@See HlmsPso

Reimplemented from Ogre::RenderSystem.

## ◆ _setPointParameters()

virtual void Ogre::NULLRenderSystem::_setPointParameters | ( | Real | size,
|  | bool | attenuationEnabled,
|  | Real | constant,
|  | Real | linear,
|  | Real | quadratic,
|  | Real | minSize,
|  | Real | maxSize
| ) |  |
| virtual

Sets the size of points and how they are attenuated with distance.

Remarks
  When performing point rendering or point sprite rendering, point size can be attenuated with distance. The equation for doing this is attenuation = 1 / (constant + linear * dist + quadratic * d^2) .

  For example, to disable distance attenuation (constant screensize) you would set constant to 1, and linear and quadratic to 0. A standard perspective attenuation would be 0, 1, 0 respectively.

Implements Ogre::RenderSystem.

## ◆ _setPointSpritesEnabled()

virtual void Ogre::NULLRenderSystem::_setPointSpritesEnabled | ( | bool | enabled | ) |
| virtual

Sets whether or not rendering points using OT_POINT_LIST will render point sprites (textured quads) or plain points.

Parameters

  enabled | True enables point sprites, false returns to normal point rendering.

Implements Ogre::RenderSystem.

## ◆ _setProjectionMatrix()

virtual void Ogre::NULLRenderSystem::_setProjectionMatrix | ( | const Matrix4 & | m | ) |
| virtual

Sets the projection transform matrix.

Implements Ogre::RenderSystem.

## ◆ _setRenderOperation()

virtual void Ogre::NULLRenderSystem::_setRenderOperation | ( | const v1::CbRenderOp * | cmd | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ _setSamplers()

virtual void Ogre::NULLRenderSystem::_setSamplers | ( | uint32 | slotStart,
|  | const DescriptorSetSampler * | set
| ) |  |
| virtual

Implements Ogre::RenderSystem.

## ◆ _setSamplersCS()

virtual void Ogre::NULLRenderSystem::_setSamplersCS | ( | uint32 | slotStart,
|  | const DescriptorSetSampler * | set
| ) |  |
| virtual

Implements Ogre::RenderSystem.

## ◆ _setSurfaceParams()

virtual void Ogre::NULLRenderSystem::_setSurfaceParams | ( | const ColourValue & | ambient,
|  | const ColourValue & | diffuse,
|  | const ColourValue & | specular,
|  | const ColourValue & | emissive,
|  | Real | shininess,
|  | TrackVertexColourType | tracking = `TVC_NONE`
| ) |  |
| virtual

Sets the surface properties to be used for future rendering.

This method sets the the properties of the surfaces of objects to be rendered after it. In this context these surface properties are the amount of each type of light the object reflects (determining it's colour under different types of light), whether it emits light itself, and how shiny it is. Textures are not dealt with here, see the _setTetxure method for details. This method is used by _setMaterial so does not need to be called direct if that method is being used.

Parameters

  ambient | The amount of ambient (sourceless and directionless) light an object reflects. Affected by the colour/amount of ambient light in the scene.
  diffuse | The amount of light from directed sources that is reflected (affected by colour/amount of point, directed and spot light sources)
  specular | The amount of specular light reflected. This is also affected by directed light sources but represents the colour at the highlights of the object.
  emissive | The colour of light emitted from the object. Note that this will make an object seem brighter and not dependent on lights in the scene, but it will not act as a light, so will not illuminate other objects. Use a light attached to the same SceneNode as the object for this purpose.
  shininess | A value which only has an effect on specular highlights (so specular must be non-black). The higher this value, the smaller and crisper the specular highlights will be, imitating a more highly polished surface. This value is not constrained to 0.0-1.0, in fact it is likely to be more (10.0 gives a modest sheen to an object).
  tracking | A bit field that describes which of the ambient, diffuse, specular and emissive colours follow the vertex colour of the primitive. When a bit in this field is set its ColourValue is ignored. This is a combination of TVC_AMBIENT, TVC_DIFFUSE, TVC_SPECULAR(note that the shininess value is still taken from shininess) and TVC_EMISSIVE. TVC_NONE means that there will be no material property tracking the vertex colours.

Implements Ogre::RenderSystem.

## ◆ _setTessellationDomainTexture()

virtual void Ogre::RenderSystem::_setTessellationDomainTexture | ( | size_t | unit,
|  | TextureGpu * | tex
| ) |  |
| virtualinherited

Reimplemented in Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _setTessellationHullTexture()

virtual void Ogre::RenderSystem::_setTessellationHullTexture | ( | size_t | unit,
|  | TextureGpu * | tex
| ) |  |
| virtualinherited

Reimplemented in Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _setTexture()

virtual void Ogre::NULLRenderSystem::_setTexture | ( | size_t | unit,
|  | TextureGpu * | texPtr
| ) |  |
| virtual

Sets the texture to bind to a given texture unit.

User processes would not normally call this direct unless rendering primitives themselves.

Parameters

  unit | The index of the texture unit to modify. Multitexturing hardware can support multiple units (see RenderSystemCapabilites::getNumTextureUnits)
  enabled | Boolean to turn the unit on/off
  texPtr | Pointer to the texture to use.

Implements Ogre::RenderSystem.

## ◆ _setTextureBlendMode()

virtual void Ogre::NULLRenderSystem::_setTextureBlendMode | ( | size_t | unit,
|  | const LayerBlendModeEx & | bm
| ) |  |
| virtual

Sets the texture blend modes from a TextureUnitState record.

Meant for use internally only - apps should use the Material and TextureUnitState classes.

Parameters

  unit | Texture unit as above
  bm | Details of the blending mode

Implements Ogre::RenderSystem.

## ◆ _setTextureCoordCalculation()

virtual void Ogre::NULLRenderSystem::_setTextureCoordCalculation | ( | size_t | unit,
|  | TexCoordCalcMethod | m,
|  | const Frustum * | frustum = `0`
| ) |  |
| virtual

Sets a method for automatically calculating texture coordinates for a stage.

Should not be used by apps - for use by Ogre only.

Parameters

  unit | Texture unit as above
  m | Calculation method to use
  frustum | Optional Frustum param, only used for projective effects

Implements Ogre::RenderSystem.

## ◆ _setTextureMatrix()

virtual void Ogre::NULLRenderSystem::_setTextureMatrix | ( | size_t | unit,
|  | const Matrix4 & | xform
| ) |  |
| virtual

Sets the texture coordinate transformation matrix for a texture unit.

Parameters

  unit | Texture unit to affect
  xform | The 4x4 matrix

Implements Ogre::RenderSystem.

## ◆ _setTextureProjectionRelativeTo()

virtual void Ogre::RenderSystem::_setTextureProjectionRelativeTo | ( | bool | enabled,
|  | const Vector3 & | pos
| ) |  |
| virtualinherited

Notify the rendersystem that it should adjust texture projection to be relative to a different origin.

## ◆ _setTextures() [1/2]

virtual void Ogre::NULLRenderSystem::_setTextures | ( | uint32 | slotStart,
|  | const DescriptorSetTexture * | set,
|  | uint32 | hazardousTexIdx
| ) |  |
| virtual

Parameters

  slotStart |
  set |
  hazardousTexIdx | When hazardousTexIdx < set->mTextures.size(); it means that we need to check if set->mTextures[hazardousTexIdx] is not the same as the currently bound RTT.

Implements Ogre::RenderSystem.

## ◆ _setTextures() [2/2]

virtual void Ogre::NULLRenderSystem::_setTextures | ( | uint32 | slotStart,
|  | const DescriptorSetTexture2 * | set
| ) |  |
| virtual

Implements Ogre::RenderSystem.

## ◆ _setTexturesCS() [1/2]

virtual void Ogre::NULLRenderSystem::_setTexturesCS | ( | uint32 | slotStart,
|  | const DescriptorSetTexture * | set
| ) |  |
| virtual

Implements Ogre::RenderSystem.

## ◆ _setTexturesCS() [2/2]

virtual void Ogre::NULLRenderSystem::_setTexturesCS | ( | uint32 | slotStart,
|  | const DescriptorSetTexture2 * | set
| ) |  |
| virtual

Implements Ogre::RenderSystem.

## ◆ _setTextureUnitSettings()

virtual void Ogre::RenderSystem::_setTextureUnitSettings | ( | size_t | texUnit,
|  | TextureUnitState & | tl
| ) |  |
| virtualinherited

Utility function for setting all the properties of a texture unit at once.

This method is also worth using over the individual texture unit settings because it only sets those settings which are different from the current settings for this unit, thus minimising render state changes.

## ◆ _setUavCS()

virtual void Ogre::NULLRenderSystem::_setUavCS | ( | uint32 | slotStart,
|  | const DescriptorSetUav * | set
| ) |  |
| virtual

Implements Ogre::RenderSystem.

## ◆ _setVertexArrayObject()

virtual void Ogre::NULLRenderSystem::_setVertexArrayObject | ( | const VertexArrayObject * | vao | ) |
| virtual

Part of the low level rendering interface.

Tells the RS which VAO will be bound now. (i.e. Vertex Formats, buffers being bound, etc.) You don't need to rebind if the VAO's mRenderQueueId is the same as previous call.

Remarks
  Assumes _setPipelineStateObject has already been called.

Implements Ogre::RenderSystem.

## ◆ _setVertexTexture()

virtual void Ogre::RenderSystem::_setVertexTexture | ( | size_t | unit,
|  | TextureGpu * | tex
| ) |  |
| virtualinherited

Binds a texture to a vertex, geometry, compute, tessellation hull or tessellation domain sampler.

Remarks
  Not all rendersystems support separate vertex samplers. For those that do, you can set a texture for them, separate to the regular texture samplers, using this method. For those that don't, you should use the regular texture samplers which are shared between the vertex and fragment units; calling this method will throw an exception.

See also
  RenderSystemCapabilites::getVertexTextureUnitsShared

Reimplemented in Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ _setViewMatrix()

virtual void Ogre::NULLRenderSystem::_setViewMatrix | ( | const Matrix4 & | m | ) |
| virtual

Sets the view transform matrix.

Implements Ogre::RenderSystem.

## ◆ _setWorldMatrices()

virtual void Ogre::RenderSystem::_setWorldMatrices | ( | const Matrix4 * | m,
|  | unsigned short | count
| ) |  |
| virtualinherited

Sets multiple world matrices (vertex blending).

## ◆ _setWorldMatrix()

virtual void Ogre::NULLRenderSystem::_setWorldMatrix | ( | const Matrix4 & | m | ) |
| virtual

Sets the world transform matrix.

Implements Ogre::RenderSystem.

## ◆ _startLegacyV1Rendering()

virtual void Ogre::RenderSystem::_startLegacyV1Rendering | ( | void |  | ) |
| inlinevirtualinherited

May override the current VertexArrayObject!

Reimplemented in Ogre::GLES2RenderSystem, and Ogre::GL3PlusRenderSystem.

## ◆ _update()

void Ogre::RenderSystem::_update | ( | void |  | ) |
| inherited

Called once per frame, regardless of how many active workspaces there are.

## ◆ _useLights()

virtual void Ogre::NULLRenderSystem::_useLights | ( | const LightList & | lights,
|  | unsigned short | limit
| ) |  |
| virtual

Tells the rendersystem to use the attached set of lights (and no others) up to the number specified (this allows the same list to be used with different count limits)

Implements Ogre::RenderSystem.

## ◆ addClipPlane() [1/2]

virtual void Ogre::RenderSystem::addClipPlane | ( | const Plane & | p | ) |
| virtualinherited

Add a user clipping plane.

## ◆ addClipPlane() [2/2]

virtual void Ogre::RenderSystem::addClipPlane | ( | Real | A,
|  | Real | B,
|  | Real | C,
|  | Real | D
| ) |  |
| virtualinherited

Add a user clipping plane.

## ◆ addListener()

virtual void Ogre::RenderSystem::addListener | ( | Listener * | l | ) |
| virtualinherited

Adds a listener to the custom events that this render system can raise.

Remarks
  Some render systems have quite specific, internally generated events that the application may wish to be notified of. Many applications don't have to worry about these events, and can just trust OGRE to handle them, but if you want to know, you can add a listener here.

  Events are raised very generically by string name. Perhaps the most common example of a render system specific event is the loss and restoration of a device in DirectX; which OGRE deals with, but you may wish to know when it happens.

See also
  RenderSystem::getRenderSystemEvents

## ◆ areFixedFunctionLightsInViewSpace()

virtual bool Ogre::RenderSystem::areFixedFunctionLightsInViewSpace | ( |  | ) | const
| inlinevirtualinherited

Are fixed-function lights provided in view space? Affects optimisation.

Reimplemented in Ogre::GLES2RenderSystem, and Ogre::GL3PlusRenderSystem.

## ◆ beginGPUSampleProfile()

virtual void Ogre::NULLRenderSystem::beginGPUSampleProfile | ( | const String & | name,
|  | uint32 * | hashCache
| ) |  |
| virtual

Implements Ogre::RenderSystem.

## ◆ beginProfileEvent()

virtual void Ogre::NULLRenderSystem::beginProfileEvent | ( | const String & | eventName | ) |
| virtual

This marks the beginning of an event for GPU profiling.

Implements Ogre::RenderSystem.

## ◆ beginRenderPassDescriptor()

virtual void Ogre::RenderSystem::beginRenderPassDescriptor | ( | RenderPassDescriptor * | desc,
|  | TextureGpu * | anyTarget,
|  | uint8 | mipLevel,
|  | const Vector4 * | viewportSizes,
|  | const Vector4 * | scissors,
|  | uint32 | numViewports,
|  | bool | overlaysEnabled,
|  | bool | warnIfRtvWasFlushed
| ) |  |
| virtualinherited

When the descriptor is set to Load clear, two possible things may happen:

1. The region is cleared.
2. The whole texture is cleared. What actually happens is undefined (depends on the API). But calling "beginRenderPassDescriptor( desc, viewportSettings );" with the same descriptor but different viewports (without changing the desc) guarantees that each region is cleared:

1. Each time the subregion is switched
2. Only once (the whole texture), when the first viewport was set.
     When switching between render targets, two beginRenderPassDescriptor in a row automatically implies calls endRenderPassDescriptor. In fact this is faster to perfom than calling beginRenderPassDescriptor - endRenderPassDescriptor in pairs, because we can smartly flush only what needs to be flushed. endRenderPassDescriptor only needs to be called when no other beginRenderPassDescriptor will follow (i.e. at the end of the frame or when starting compute jobs)
   Parameters

     desc |
     anyTarget | Contains the first valid texture in mRenderPassDesc, to be used for reference (e.g. width, height, etc). Could be colour, depth, stencil, or nullptr.
     mipLevel | Mip at which anyTarget is bound
     viewportSize |
     warnIfRtvWasFlushed | See CompositorPassDef::mWarnIfRtvWasFlushed

Reimplemented in Ogre::MetalRenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ bindGpuProgramParameters()

virtual void Ogre::NULLRenderSystem::bindGpuProgramParameters | ( | GpuProgramType | gptype,
|  | GpuProgramParametersSharedPtr | params,
|  | uint16 | variabilityMask
| ) |  |
| virtual

Bind Gpu program parameters.

Parameters

  gptype | The type of program to bind the parameters to
  params | The parameters to bind
  variabilityMask | A mask of GpuParamVariability identifying which params need binding

Implements Ogre::RenderSystem.

## ◆ bindGpuProgramPassIterationParameters()

virtual void Ogre::NULLRenderSystem::bindGpuProgramPassIterationParameters | ( | GpuProgramType | gptype | ) |
| virtual

Only binds Gpu program parameters used for passes that have more than one iteration rendering.

Implements Ogre::RenderSystem.

## ◆ checkExtension()

virtual bool Ogre::RenderSystem::checkExtension | ( | const String & | ext | ) | const
| inlinevirtualinherited

Checks for the presense of an API-specific extension (eg. Vulkan, GL)

Reimplemented in Ogre::GLES2RenderSystem.

## ◆ clearFrameBuffer()

virtual void Ogre::NULLRenderSystem::clearFrameBuffer | ( | RenderPassDescriptor * | renderPassDesc,
|  | TextureGpu * | anyTarget,
|  | uint8 | mipLevel
| ) |  |
| virtual

Immediately clears the whole frame buffer on the selected RenderPassDescriptor.

Prefer clearing using the LoadAction semantics in the RenderPassDescriptor. This function is provided for two reasons:

1. Backwards compatibility (i.e. easier porting from 2.1)
2. Non-tilers desktop GPUs may be faster to clear the whole framebuffer at once.
   Remarks
     Will break an existing RenderPassDescriptor set via beginRenderPassDescriptor.
   Parameters

     renderPassDesc | RenderPassDescriptor filled with LoadActions set to clear and StoreActions set to Store.

Implements Ogre::RenderSystem.

## ◆ convertColourValue()

virtual void Ogre::RenderSystem::convertColourValue | ( | const ColourValue & | colour,
|  | uint32 * | pDest
| ) |  |
| virtualinherited

Generates a packed data version of the passed in ColourValue suitable for use as with this RenderSystem.

Remarks
  Since different render systems have different colour data formats (eg RGBA for GL, ARGB for D3D) this method allows you to use 1 method for all.

Parameters

  colour | The colour to convert
  pDest | Pointer to location to put the result.

## ◆ createHardwareOcclusionQuery()

virtual HardwareOcclusionQuery* Ogre::NULLRenderSystem::createHardwareOcclusionQuery | ( | void |  | ) |
| virtual

Create an object for performing hardware occlusion queries.

Implements Ogre::RenderSystem.

## ◆ createRenderPassDescriptor()

virtual RenderPassDescriptor* Ogre::NULLRenderSystem::createRenderPassDescriptor | ( | void |  | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ createRenderSystemCapabilities()

virtual RenderSystemCapabilities* Ogre::NULLRenderSystem::createRenderSystemCapabilities | ( | void |  | ) | const
| virtual

Query the real capabilities of the GPU and driver in the RenderSystem.

Implements Ogre::RenderSystem.

## ◆ deinitGPUProfiling()

virtual void Ogre::NULLRenderSystem::deinitGPUProfiling | ( | void |  | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ destroyHardwareOcclusionQuery()

virtual void Ogre::RenderSystem::destroyHardwareOcclusionQuery | ( | HardwareOcclusionQuery * | hq | ) |
| virtualinherited

Destroy a hardware occlusion query object.

## ◆ destroyRenderPassDescriptor()

void Ogre::RenderSystem::destroyRenderPassDescriptor | ( | RenderPassDescriptor * | renderPassDesc | ) |
| inherited

## ◆ destroyRenderWindow()

virtual void Ogre::RenderSystem::destroyRenderWindow | ( | Window * | window | ) |
| virtualinherited

Destroys a render window.

## ◆ endGPUSampleProfile()

virtual void Ogre::NULLRenderSystem::endGPUSampleProfile | ( | const String & | name | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ endProfileEvent()

virtual void Ogre::NULLRenderSystem::endProfileEvent | ( | void |  | ) |
| virtual

Ends the currently active GPU profiling event.

Implements Ogre::RenderSystem.

## ◆ endRenderPassDescriptor()

virtual void Ogre::RenderSystem::endRenderPassDescriptor | ( | void |  | ) |
| virtualinherited

Reimplemented in Ogre::MetalRenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ executeRenderPassDescriptorDelayedActions()

virtual void Ogre::RenderSystem::executeRenderPassDescriptorDelayedActions | ( | void |  | ) |
| virtualinherited

Metal needs to delay RenderCommand creation to the last minute, because we can't issue blit operations (e.g.

buffer copies) which a lot of v1 code relies on otherwise the RenderCommand gets canceled. Even if we were to get rid of v1 operations, the user may want to hook listeners for _renderPhase02 and perform forbidden operations. Therefore it's easier to split the process done in beginRenderPassDescriptor in two steps (beginRenderPassDescriptor and executeRenderPassDescriptorDelayedActions) for Metal.

Reimplemented in Ogre::MetalRenderSystem.

## ◆ flushCommands()

virtual void Ogre::NULLRenderSystem::flushCommands | ( | void |  | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ flushUAVs()

virtual void Ogre::NULLRenderSystem::flushUAVs | ( | void |  | ) |
| virtual

Forces to take effect all the queued UAV binding requests.

See also
  _queueBindUAV. You don't need to call this if you're going to set the render target next.

Implements Ogre::RenderSystem.

## ◆ getCapabilities()

const RenderSystemCapabilities* Ogre::RenderSystem::getCapabilities | ( | void |  | ) | const
| inlineinherited

Gets the capabilities of the render system.

## ◆ getColourVertexElementType()

virtual VertexElementType Ogre::NULLRenderSystem::getColourVertexElementType | ( | void |  | ) | const
| virtual

Get the native VertexElementType for a compact 32-bit colour value for this rendersystem.

Implements Ogre::RenderSystem.

## ◆ getConfigOptions()

virtual ConfigOptionMap& Ogre::NULLRenderSystem::getConfigOptions | ( | void |  | ) |
| inlinevirtual

Returns the details of this API's configuration options.

Remarks
  Each render system must be able to inform the world of what options must/can be specified for it's operation.

  These are passed as strings for portability, but grouped into a structure (_ConfigOption) which includes both options and current value.

  Note that the settings returned from this call are affected by the options that have been set so far, since some options are interdependent.

  This routine is called automatically by the default configuration dialogue produced by Root::showConfigDialog or may be used by the caller for custom settings dialogs

Returns
  A 'map' of options, i.e. a list of options which is also indexed by option name.

Implements Ogre::RenderSystem.

## ◆ getCurrentPassDescriptor()

RenderPassDescriptor* Ogre::RenderSystem::getCurrentPassDescriptor | ( | void |  | ) |
| inlineinherited

## ◆ getCurrentRenderViewports()

Viewport* Ogre::RenderSystem::getCurrentRenderViewports | ( | void |  | ) |
| inlineinherited

## ◆ getCustomAttribute()

virtual void Ogre::RenderSystem::getCustomAttribute | ( | const String & | name,
|  | void * | pData
| ) |  |
| virtualinherited

Gets a custom (maybe platform-specific) attribute.

Remarks
  This is a nasty way of satisfying any API's need to see platform-specific details.

Parameters

  name | The name of the attribute.
  pData | Pointer to memory of the right kind of structure to receive the info.

Reimplemented in Ogre::D3D11RenderSystem.

## ◆ getDebugShaders()

bool Ogre::RenderSystem::getDebugShaders | ( | void |  | ) | const
| inlineinherited

## ◆ getDepthBufferFor()

virtual TextureGpu* Ogre::RenderSystem::getDepthBufferFor | ( | TextureGpu * | colourTexture,
|  | uint16 | poolId,
|  | bool | preferDepthTexture,
|  | PixelFormatGpu | depthBufferFormat
| ) |  |
| virtualinherited

## ◆ getDisplayMonitorCount()

virtual unsigned int Ogre::NULLRenderSystem::getDisplayMonitorCount | ( |  | ) | const
| inlinevirtual

Gets the number of display monitors.

See also
  Root::getDisplayMonitorCount

Implements Ogre::RenderSystem.

## ◆ getDriverVersion()

virtual const DriverVersion& Ogre::RenderSystem::getDriverVersion | ( | void |  | ) | const
| inlinevirtualinherited

Returns the driver version.

## ◆ getErrorDescription()

virtual String Ogre::NULLRenderSystem::getErrorDescription | ( | long | errorNumber | ) | const
| virtual

Returns a description of an error code.

Implements Ogre::RenderSystem.

## ◆ getFriendlyName()

virtual const String& Ogre::NULLRenderSystem::getFriendlyName | ( | void |  | ) | const
| virtual

Returns the friendly name of the render system.

Implements Ogre::RenderSystem.

## ◆ getGlobalInstanceVertexBuffer()

v1::HardwareVertexBufferSharedPtr Ogre::RenderSystem::getGlobalInstanceVertexBuffer | ( |  | ) | const
| inherited

Returns the global instance vertex buffer.

## ◆ getGlobalInstanceVertexBufferVertexDeclaration()

v1::VertexDeclaration* Ogre::RenderSystem::getGlobalInstanceVertexBufferVertexDeclaration | ( |  | ) | const
| inherited

Gets vertex declaration for the global vertex buffer for the global instancing.

## ◆ getGlobalNumberOfInstances()

size_t Ogre::RenderSystem::getGlobalNumberOfInstances | ( |  | ) | const
| inherited

Gets the global number of instances.

## ◆ getHorizontalTexelOffset()

virtual Real Ogre::NULLRenderSystem::getHorizontalTexelOffset | ( | void |  | ) |
| virtual

Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Remarks
  Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the horizontal direction.

Implements Ogre::RenderSystem.

## ◆ getInvertVertexWinding()

virtual bool Ogre::RenderSystem::getInvertVertexWinding | ( | void |  | ) | const
| virtualinherited

Indicates whether or not the vertex windings set will be inverted for the current render (e.g.

reflections)

See also
  RenderSystem::setInvertVertexWinding

## ◆ getMaxBoundViewports()

uint32 Ogre::RenderSystem::getMaxBoundViewports | ( | void |  | ) |
| inlineinherited

## ◆ getMaximumDepthInputValue()

virtual Real Ogre::NULLRenderSystem::getMaximumDepthInputValue | ( | void |  | ) |
| virtual

Gets the maximum (farthest) depth value to be used when rendering using identity transforms.

Remarks
  When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implements Ogre::RenderSystem.

## ◆ getMetrics()

const Metrics& Ogre::RenderSystem::getMetrics | ( |  | ) | const
| inherited

## ◆ getMinimumDepthInputValue()

virtual Real Ogre::NULLRenderSystem::getMinimumDepthInputValue | ( | void |  | ) |
| virtual

Gets the minimum (closest) depth value to be used when rendering using identity transforms.

Remarks
  When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implements Ogre::RenderSystem.

## ◆ getMutableCapabilities()

RenderSystemCapabilities* Ogre::RenderSystem::getMutableCapabilities | ( |  | ) |
| inlineinherited

Get a pointer to the current capabilities being used by the RenderSystem.

Remarks
  The capabilities may be modified using this pointer, this will only have an effect before the RenderSystem has been initialised. It's intended use is to allow a listener of the RenderSystemCapabilitiesCreated event to customise the capabilities on the fly before the RenderSystem is initialised.

## ◆ getName()

virtual const String& Ogre::NULLRenderSystem::getName | ( | void |  | ) | const
| virtual

Returns the name of the rendering system.

Implements Ogre::RenderSystem.

## ◆ getNativeShadingLanguageVersion()

uint16 Ogre::RenderSystem::getNativeShadingLanguageVersion | ( |  | ) | const
| inlineinherited

Gets the native shading language version for this render system.

Formatted so that it can be used within a shading program. For example, OpenGL 3.2 would return 150, while 3.3 would return 330

## ◆ getPixelFormatToShaderType()

virtual const PixelFormatToShaderType* Ogre::NULLRenderSystem::getPixelFormatToShaderType | ( | void |  | ) | const
| virtual

Implements Ogre::RenderSystem.

## ◆ getRenderSystemEvents()

virtual const StringVector& Ogre::RenderSystem::getRenderSystemEvents | ( | void |  | ) | const
| inlinevirtualinherited

Gets a list of the rendersystem specific events that this rendersystem can raise.

See also
  RenderSystem::addListener

## ◆ getRSDepthRange()

virtual Real Ogre::RenderSystem::getRSDepthRange | ( | void |  | ) | const
| inlinevirtualinherited

OpenGL depth is in range [-1;1] so it returns 2.0f; D3D11 & Metal are in range [0;1] so it returns 1.0f;.

Note OpenGL may behave like D3D11, and thus we'll return 1.0f too. This is decided at runtime, not at compile time.

Reimplemented in Ogre::GL3PlusRenderSystem.

## ◆ getSharedListener()

static Listener* Ogre::RenderSystem::getSharedListener | ( | void |  | ) |
| staticinherited

Retrieve a pointer to the current shared render system listener.

## ◆ getStencilBufferParams()

const StencilParams& Ogre::RenderSystem::getStencilBufferParams | ( | void |  | ) | const
| inlineinherited

## ◆ getTextureGpuManager()

TextureGpuManager* Ogre::RenderSystem::getTextureGpuManager | ( | void |  | ) | const
| inlineinherited

## ◆ getVaoManager()

VaoManager* Ogre::RenderSystem::getVaoManager | ( | void |  | ) | const
| inlineinherited

## ◆ getVerticalTexelOffset()

virtual Real Ogre::NULLRenderSystem::getVerticalTexelOffset | ( | void |  | ) |
| virtual

Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Remarks
  Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the vertical direction.

Implements Ogre::RenderSystem.

## ◆ getWBufferEnabled()

bool Ogre::RenderSystem::getWBufferEnabled | ( | void |  | ) | const
| inherited

Returns true if the renderer will try to use W-buffers when available.

## ◆ hasAnisotropicMipMapFilter()

virtual bool Ogre::NULLRenderSystem::hasAnisotropicMipMapFilter | ( |  | ) | const
| inlinevirtual

Determines if the system has anisotropic mip map filter support.

Implements Ogre::RenderSystem.

## ◆ initGPUProfiling()

virtual void Ogre::NULLRenderSystem::initGPUProfiling | ( | void |  | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ initialiseFromRenderSystemCapabilities()

virtual void Ogre::NULLRenderSystem::initialiseFromRenderSystemCapabilities | ( | RenderSystemCapabilities * | caps,
|  | Window * | primary
| ) |  |
| virtual

Initialize the render system from the capabilities.

Implements Ogre::RenderSystem.

## ◆ isGpuProgramBound()

virtual bool Ogre::RenderSystem::isGpuProgramBound | ( | GpuProgramType | gptype | ) |
| virtualinherited

Returns whether or not a Gpu program of the given type is currently bound.

## ◆ isReverseDepth()

bool Ogre::RenderSystem::isReverseDepth | ( | void |  | ) | const
| inlineinherited

## ◆ isStaticBufferLockable()

virtual bool Ogre::RenderSystem::isStaticBufferLockable | ( |  | ) | const
| inlinevirtualinherited

Reimplemented in Ogre::D3D9RenderSystem.

## ◆ markProfileEvent()

virtual void Ogre::NULLRenderSystem::markProfileEvent | ( | const String & | event | ) |
| virtual

Marks an instantaneous event for graphics profilers.

This is equivalent to calling

See also
  beginProfileEvent and
  endProfileEvent back to back.

Implements Ogre::RenderSystem.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ postExtraThreadsStarted()

virtual void Ogre::NULLRenderSystem::postExtraThreadsStarted | ( |  | ) |
| virtual

Implements Ogre::RenderSystem.

## ◆ preExtraThreadsStarted()

virtual void Ogre::NULLRenderSystem::preExtraThreadsStarted | ( |  | ) |
| virtual

Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might access the rendering API are registered.

Remarks
  Call this from your main thread before starting your other threads (which themselves should call registerThread()). Note that if you start your own threads, there is a specific startup sequence which must be respected and requires synchronisation between the threads:
  1. [Main thread]Call preExtraThreadsStarted
  2. [Main thread]Start other thread, wait
  3. [Other thread]Call registerThread, notify main thread & continue
  4. [Main thread]Wake up & call postExtraThreadsStarted
  Once this init sequence is completed the threads are independent but this startup sequence must be respected.

Implements Ogre::RenderSystem.

## ◆ queueBindUAVs()

void Ogre::RenderSystem::queueBindUAVs | ( | const DescriptorSetUav * | descSetUav | ) |
| inherited

Queues the binding of an UAV to the binding point/slot.

It won't actually take effect until you flush the UAVs or set another RTT.

Remarks
  Internal Developer Notes: D3D11 keeps UAVs that affect rendering separate from UAVs that affect Compute Shaders. Hence queueBindUAVs & _setTextureCS are independent.

OpenGL however, does not make this distinction. Hence once we switch back to 3D rendering, we need to restore UAVs set via queueBindUAV.

## ◆ registerThread()

virtual void Ogre::NULLRenderSystem::registerThread | ( |  | ) |
| virtual

Register the an additional thread which may make calls to rendersystem-related objects.

Remarks
  This method should only be called by additional threads during their initialisation. If they intend to use hardware rendering system resources they should call this method before doing anything related to the render system. Some rendering APIs require a per-thread setup and this method will sort that out. It is also necessary to call unregisterThread before the thread shuts down.

Note
  This method takes no parameters - it must be called from the thread being registered and that context is enough.

Implements Ogre::RenderSystem.

## ◆ reinitialise()

virtual void Ogre::NULLRenderSystem::reinitialise | ( | void |  | ) |
| virtual

Restart the renderer (normally following a change in settings).

Implements Ogre::RenderSystem.

## ◆ removeListener()

virtual void Ogre::RenderSystem::removeListener | ( | Listener * | l | ) |
| virtualinherited

Remove a listener to the custom events that this render system can raise.

## ◆ resetClipPlanes()

virtual void Ogre::RenderSystem::resetClipPlanes | ( |  | ) |
| virtualinherited

Clears the user clipping region.

## ◆ reverseCompareFunction()

static CompareFunction Ogre::RenderSystem::reverseCompareFunction | ( | CompareFunction | depthFunc | ) |
| staticinherited

Reverts the compare order e.g.

greater_equal becomes less_equal Used by reverse depth

Parameters

  depthFunc |

Returns

## ◆ setClipPlanes()

virtual void Ogre::RenderSystem::setClipPlanes | ( | const PlaneList & | clipPlanes | ) |
| virtualinherited

Sets the user clipping region.

## ◆ setClipPlanesImpl()

virtual void Ogre::NULLRenderSystem::setClipPlanesImpl | ( | const PlaneList & | clipPlanes | ) |
| virtual

Internal method used to set the underlying clip planes when needed.

Implements Ogre::RenderSystem.

## ◆ setConfigOption()

virtual void Ogre::NULLRenderSystem::setConfigOption | ( | const String & | name,
|  | const String & | value
| ) |  |
| inlinevirtual

Sets an option for this API.

Remarks
  Used to confirm the settings (normally chosen by the user) in order to make the renderer able to initialise with the settings as required. This may be video mode, D3D driver, full screen / windowed etc. Called automatically by the default configuration dialog, and by the restoration of saved settings. These settings are stored and only activated when RenderSystem::initialise or RenderSystem::reinitialise are called.

  If using a custom configuration dialog, it is advised that the caller calls RenderSystem::getConfigOptions again, since some options can alter resulting from a selection.

Parameters

  name | The name of the option to alter.
  value | The value to set the option to.

Implements Ogre::RenderSystem.

## ◆ setCurrentPassIterationCount()

virtual void Ogre::RenderSystem::setCurrentPassIterationCount | ( | const size_t | count | ) |
| inlinevirtualinherited

set the current multi pass count value.

This must be set prior to calling _render() if multiple renderings of the same pass state are required.

Parameters

  count | Number of times to render the current state.

## ◆ setDebugShaders()

void Ogre::RenderSystem::setDebugShaders | ( | bool | bDebugShaders | ) |
| inherited

Instructs the RenderSystem to compile shaders without optimizations and with debug information, for easier debugging on APIs that support it.

Default is true if OGRE_DEBUG_MODE >= OGRE_DEBUG_HIGH, else false

This setting takes effect for shaders compiled afterwards. Already compiled shaders won't change unless you manually rebuild them.

It is highly recommended you disable the Microcode cache before changing the default, or else debug shaders may contaminate your cache, or alternatively a shader from the cache may be used which may have been compiled with a different setting.

## ◆ setDeriveDepthBias()

virtual void Ogre::RenderSystem::setDeriveDepthBias | ( | bool | derive,
|  | float | baseValue = `0.0f`,
|  | float | multiplier = `0.0f`,
|  | float | slopeScale = `0.0f`
| ) |  |
| inlinevirtualinherited

Tell the render system whether to derive a depth bias on its own based on the values passed to it in setCurrentPassIterationCount.

The depth bias set will be baseValue + iteration * multiplier

Parameters

  derive | True to tell the RS to derive this automatically
  baseValue | The base value to which the multiplier should be added
  multiplier | The amount of depth bias to apply per iteration
  slopeScale | The constant slope scale bias for completeness

## ◆ setDrawBuffer()

virtual bool Ogre::RenderSystem::setDrawBuffer | ( | ColourBufferType | colourBuffer | ) |
| inlinevirtualinherited

Sets the colour buffer that the render system will to draw.

If the render system implementation or configuration does not support a particular value, then false will be returned and the current colour buffer value will not be modified.

Parameters

  colourBuffer | Specifies the colour buffer that will be drawn into.

Reimplemented in Ogre::D3D9RenderSystem, and Ogre::D3D11RenderSystem.

## ◆ setGlobalInstanceVertexBuffer()

void Ogre::RenderSystem::setGlobalInstanceVertexBuffer | ( | const v1::HardwareVertexBufferSharedPtr & | val | ) |
| inherited

Sets the global instance vertex buffer.

## ◆ setGlobalInstanceVertexBufferVertexDeclaration()

void Ogre::RenderSystem::setGlobalInstanceVertexBufferVertexDeclaration | ( | v1::VertexDeclaration * | val | ) |
| inherited

Sets vertex declaration for the global vertex buffer for the global instancing.

## ◆ setGlobalNumberOfInstances()

void Ogre::RenderSystem::setGlobalNumberOfInstances | ( | const size_t | val | ) |
| inherited

Sets the global number of instances.

## ◆ setInvertVertexWinding()

void Ogre::RenderSystem::setInvertVertexWinding | ( | bool | invert | ) |
| inherited

Sets whether or not vertex windings set should be inverted; this can be important for rendering reflections.

## ◆ setMetricsRecordingEnabled()

void Ogre::RenderSystem::setMetricsRecordingEnabled | ( | bool | bEnable | ) |
| inherited

## ◆ setSharedListener()

static void Ogre::RenderSystem::setSharedListener | ( | Listener * | listener | ) |
| staticinherited

Sets shared listener.

Remarks
  Shared listener could be set even if no render system is selected yet. This listener will receive "RenderSystemChanged" event on each Root::setRenderSystem call.

## ◆ setStencilBufferParams()

virtual void Ogre::RenderSystem::setStencilBufferParams | ( | uint32 | refValue,
|  | const StencilParams & | stencilParams
| ) |  |
| virtualinherited

This method allows you to set all the stencil buffer parameters in one call.

Remarks
  The stencil buffer is used to mask out pixels in the render target, allowing you to do effects like mirrors, cut-outs, stencil shadows and more. Each of your batches of rendering is likely to ignore the stencil buffer, update it with new values, or apply it to mask the output of the render. The stencil test is:

      (Reference Value & Mask) CompareFunction (Stencil Buffer Value & Mask)

  The result of this will cause one of 3 actions depending on whether the test fails, succeeds but with the depth buffer check still failing, or succeeds with the depth buffer check passing too.

  Unlike other render states, stencilling is left for the application to turn on and off when it requires. This is because you are likely to want to change parameters between batches of arbitrary objects and control the ordering yourself. In order to batch things this way, you'll want to use OGRE's separate render queue groups (see RenderQueue) and register a RenderQueueListener to get notifications between batches.

Parameters

  refValue | The reference value used in the comparison (dynamic)
  stencilParams | The static parameters that involve more expensive state changes. Ogre dev implementors note: Should check if the stencilParams are different from before

Reimplemented in Ogre::MetalRenderSystem, Ogre::GLES2RenderSystem, Ogre::GL3PlusRenderSystem, and Ogre::D3D11RenderSystem.

## ◆ setUavStartingSlot()

void Ogre::RenderSystem::setUavStartingSlot | ( | uint32 | startingSlot | ) |
| inherited

In Direct3D11, UAV & RenderTargets share the same slots.

Because of this, we enforce the same behavior on all RenderSystems. An unfortunate consequence is that if you attach an MRT consisting of 3 RTs; the UAV needs to set at slot 3; not slot 0. This setting lets you tell Ogre the starting slot; so queueBindUAVs( descSet ) goes from slot 3 onwards if you call setUavStartingSlot( 3 )

  Ogre will raise an exception in D3D11 if the starting slot is lower than the number of attached RTs, but will let it pass if you're using GL3+ [TODO: Make this behavior consistent?]

Remarks
  Will not take effect until the next call to flushUAVs or setting a new RTT.

Parameters

  startingSlot | Default value: 1.

## ◆ setWBufferEnabled()

void Ogre::RenderSystem::setWBufferEnabled | ( | bool | enabled | ) |
| inherited

Sets whether or not W-buffers are enabled if they are available for this renderer.

Parameters

  enabled | If true and the renderer supports them W-buffers will be used. If false W-buffers will not be used even if available. W-buffers are enabled by default for 16bit depth buffers and disabled for all other depths.

## ◆ shutdown()

virtual void Ogre::NULLRenderSystem::shutdown | ( | void |  | ) |
| virtual

Shutdown the renderer and cleanup resources.

Reimplemented from Ogre::RenderSystem.

## ◆ unregisterThread()

virtual void Ogre::NULLRenderSystem::unregisterThread | ( |  | ) |
| virtual

Unregister an additional thread which may make calls to rendersystem-related objects.

See also
  RenderSystem::registerThread

Implements Ogre::RenderSystem.

## ◆ updateCompositorManager()

virtual void Ogre::RenderSystem::updateCompositorManager | ( | CompositorManager2 * | compositorManager | ) |
| virtualinherited

This gives the renderer a chance to perform the compositor update in a special way.

When the render system is ready to perform the actual update it should just compositorManager->_updateImplementation.

Reimplemented in Ogre::MetalRenderSystem.

## ◆ useCustomRenderSystemCapabilities()

virtual void Ogre::RenderSystem::useCustomRenderSystemCapabilities | ( | RenderSystemCapabilities * | capabilities | ) |
| virtualinherited

Force the render system to use the special capabilities.

Can only be called before the render system has been fully initializer (before createWindow is called)

Parameters

  capabilities | has to be a subset of the real capabilities and the caller is responsible for deallocating capabilities.

## ◆ validateConfigOptions()

virtual String Ogre::NULLRenderSystem::validateConfigOptions | ( | void |  | ) |
| inlinevirtual

Validates the options set for the rendering system, returning a message if there are problems.

Note
  If the returned string is empty, there are no problems.

Implements Ogre::RenderSystem.

References Ogre::BLANKSTRING.

## ◆ validateDevice()

virtual bool Ogre::RenderSystem::validateDevice | ( | bool | forceDeviceElection = `false` | ) |
| inlinevirtualinherited

Some render systems have moments when GPU device is temporarily unavailable, for example when D3D11 device is lost, or when iOS app is in background, etc.

Reimplemented in Ogre::D3D11RenderSystem.

## ◆ validateSampleDescription()

virtual SampleDescription Ogre::RenderSystem::validateSampleDescription | ( | const SampleDescription & | sampleDesc,
|  | PixelFormatGpu | format
| ) |  |
| virtualinherited

Returns supported sample description for requested FSAA mode, with graceful downgrading.

Reimplemented in Ogre::MetalRenderSystem, and Ogre::D3D11RenderSystem.

The documentation for this class was generated from the following file:

- OgreNULLRenderSystem.h